'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Group = function (_Component) {
    _inherits(Group, _Component);

    function Group() {
        var _Object$getPrototypeO;

        var _temp, _this, _ret;

        _classCallCheck(this, Group);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Group)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.getComponents = function () {
            var _this$props = _this.props;
            var layout = _this$props.layout;
            var componentFactory = _this$props.componentFactory;
            var fields = _this$props.fields;

            var components = void 0;

            if (layout.fields) {

                components = layout.fields.map(function (field) {
                    var fieldMetadata = fields.find(function (cp) {
                        return cp.name === field.name;
                    });

                    if (!fieldMetadata) {
                        throw Error('Could not find field. Field: ' + field.name);
                    }

                    // in case the field is going to render layouts internally, it's going to need information about the
                    // layout and fields. I'm not sure if this is the best way to do it, probably not. TODO: Review it.
                    fieldMetadata._extra = { layout: layout, fields: fields };

                    return {
                        data: fieldMetadata,
                        length: layout.fields.length,
                        component: componentFactory.buildFieldComponent(fieldMetadata)
                    };
                });
            } else if (layout.groups) {

                components = layout.groups.map(function (group) {
                    return {
                        data: group,
                        length: layout.groups.length,
                        component: componentFactory.buildGroupComponent({
                            component: group.component,
                            layout: group,
                            fields: fields,
                            componentFactory: componentFactory
                        })
                    };
                });
            }

            return components;
        }, _this.getDefaultSize = function (component) {
            var gridLength = arguments.length <= 1 || arguments[1] === undefined ? 12 : arguments[1];
            var layout = _this.props.layout;


            return layout.orientation == 'horizontal' ? Math.floor(gridLength / component.length) : gridLength;
        }, _this.getContent = function () {
            var components = _this.getComponents();

            return components.map(function (component, i) {
                var componentContent = void 0,
                    size = 12;

                // invisible components should be hidden
                if (component.data.visible === false) {
                    componentContent = null;
                } else {
                    size = component.data.size || _this.getDefaultSize(component);
                    componentContent = component.component;
                }

                return _react2.default.createElement(
                    'div',
                    { key: 'component-' + i + '-wrapper', className: 'col-md-' + size },
                    componentContent
                );
            });
        }, _this.getHeader = function () {
            var layout = _this.props.layout;


            if (layout.title) {
                return _react2.default.createElement(
                    'header',
                    { className: 'metaform-group-header' },
                    _react2.default.createElement(
                        'span',
                        { className: 'metaform-group-title' },
                        layout.title
                    )
                );
            } else {
                return null;
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Group, [{
        key: 'render',
        value: function render() {

            // the passed in layout can contain either fields or groups.
            // in case it contains 'fields', we're gonna render each of the fields.
            // in case it contains 'groups', we're gonna render render each group, passing the fields as a parameter
            try {
                var content = this.getContent();
                var header = this.getHeader();

                return _react2.default.createElement(
                    'section',
                    null,
                    _react2.default.createElement(
                        'div',
                        { className: 'row' },
                        _react2.default.createElement(
                            'div',
                            { className: 'metaform-group' },
                            header,
                            _react2.default.createElement(
                                'div',
                                { className: 'metaform-group-content' },
                                content
                            )
                        )
                    )
                );
            } catch (ex) {
                return _react2.default.createElement(
                    _reactBootstrap.Alert,
                    { bsStyle: 'danger' },
                    _react2.default.createElement(
                        'h4',
                        null,
                        'Could not render the MetaFormGroup component. The schema is not valid.'
                    ),
                    _react2.default.createElement(
                        'p',
                        null,
                        'Detailed information:',
                        _react2.default.createElement(
                            'b',
                            null,
                            ex.message
                        )
                    )
                );
            }
        }
    }]);

    return Group;
}(_react.Component);

Group.propTypes = {
    component: _react.PropTypes.string,
    fields: _react.PropTypes.array.isRequired,
    layout: _react.PropTypes.object.isRequired,
    componentFactory: _react.PropTypes.object.isRequired
};
exports.default = Group;
module.exports = exports['default'];